#include "StdAfx.h"
#include "NtalkDragData.h"
#include "NeMessengerDlg.h"
#include "WorkGroupController.h"

IMPLEMENT_SERIAL(CNtalkDragData, CObject, 1)

CNtalkDragData::CNtalkDragData(void)
{
	m_strID = _T("");
	m_strName = _T("");
	m_strNickName = _T("");
	m_strExtensionTel = _T("");
	m_strCellphone = _T("");
	m_strJobPos = _T("");
	m_strJobDuty = _T("");
	m_strDeptName = _T("");
	m_nUserStatus = ustOFFLINE;
    m_hWndSrc = NULL;
}

CNtalkDragData::~CNtalkDragData(void)
{
}

void CNtalkDragData::Serialize(CArchive &ar)
{
	CObject::Serialize(ar);

	if (ar.IsStoring())
	{
		ar << m_nUserStatus << m_strID << m_strName << m_strNickName << m_strExtensionTel << m_strCellphone << m_strJobPos << m_strJobDuty << m_strDeptName<<(int)m_hWndSrc;
	}
	else
	{
		int nWnd = 0;;
		ar >> (int)m_nUserStatus >> m_strID >> m_strName >> m_strNickName >> m_strExtensionTel >> m_strCellphone >> m_strJobPos >> m_strJobDuty >> m_strDeptName >>(int) nWnd;
		m_hWndSrc = (HWND)nWnd;
	}
}

void CNtalkDragData::SetBuddyUser( /*const IGTBuddyUser* pUser,*/ const NE_MEMBER_DATA* pData, CArchive& ar )
{
	if (pData)
	{
		m_strID = pData->strUserId.c_str();
		m_strName = pData->strName.c_str();
		m_strNickName = pData->strNickName.c_str();
		const IGTBuddyUser* pUser = (const IGTBuddyUser*)(g_pMessengerActor->GetBuddyInfo(m_strID));
        if (NULL == pUser)
        {
			pUser = (const IGTBuddyUser*)(g_pMessengerActor->GetBuddyInfoFromPersist(m_strID));

        }
        	

		m_nUserStatus = pUser->GetStatus();
		m_strExtensionTel = pData->strExtesion.c_str();
		m_strCellphone = pData->strCellPhone.c_str();
		m_strJobPos = pData->strJobPos.c_str();
		m_strJobDuty = pData->strJobDuty.c_str();
		m_strDeptName = pData->strDept.c_str();
	}

	Serialize(ar);	
}

void CNtalkDragData::SetOrgUser( const NE_MEMBER_DATA* pData, CArchive& ar )
{
	m_strID = pData->strUserId.c_str();
	m_strName = pData->strName.c_str();
	m_strNickName = pData->strNickName.c_str();
	
	GTUserStatusType eUserStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMemberStatus(m_strID);

	m_nUserStatus =eUserStatus;

	if (pData)
	{
		m_strExtensionTel = pData->strExtesion.c_str();
		m_strCellphone = pData->strCellPhone.c_str();
		m_strJobPos = pData->strJobPos.c_str();
		m_strJobDuty = pData->strJobDuty.c_str();
		m_strDeptName = pData->strDept.c_str();
	}

	Serialize(ar);	
}

CArchive &AFXAPI operator<<(CArchive &ar, CNtalkDragData &data)
{
	data.Serialize(ar);
	return ar;
}

CArchive &AFXAPI operator>>(CArchive &ar, CNtalkDragData &data)
{
	data.Serialize(ar);
	return ar;
}
